package cheddar.osate2_plugin;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.osate.aadl2.instance.SystemInstance;
import org.osate.ui.handlers.AaxlReadOnlyHandlerAsJob;

public abstract class Abstract_Plugin extends AaxlReadOnlyHandlerAsJob {


	public void setSummaryReport() {
			this.summaryReport = new StringBuffer();
	}


	public void invoke(IProgressMonitor monitor, SystemInstance root) {
			actionBody(monitor, root);
	}

	// Compute the Cheddar directory name where cheddar pout all produced files
	//
	public String getCheddarOutputFolder(SystemInstance si)
	{
		String directory_name = "";

		if (Config.Use_Default_Working_Directory) {

			// store in the workspace folder
			//
			// directory_name = ResourcesPlugin.getWorkspace().getRoot().getLocation().toString();

			// store in the AADL project folder
			//
			Resource res = si.eResource();
			URI uri = res.getURI();
			IPath path = ResourcesPlugin.getWorkspace().getRoot().getFile(new Path(uri.toPlatformString(true)))
					.getFullPath();

			String[] segments = path.segments();
			String project_name = segments[0];

			Debug.Put("Project name for the Cheddar models :" + project_name);
			IProject prj = ResourcesPlugin.getWorkspace().getRoot().getProject(project_name);
			directory_name = prj.getLocation().toString();
			Debug.Put("Output folder for the Cheddar models :" + directory_name);

		} else {
		directory_name = Config.Cheddar_Output_Folder;
		}

		directory_name = directory_name + "/cheddar_models/";

		return directory_name;
	}



	// Write Cheddar Model XML file and return full path of the
	// generated file
	//
	public String WriteCheddarXML(SystemInstance si, String content, String name) {

		String full_name;
		String directory_name = getCheddarOutputFolder(si);

			File f = new File(directory_name);
			f.mkdir();
			full_name = directory_name + name + ".xmlv3";

			try {
			BufferedWriter out = new BufferedWriter(new FileWriter(full_name));
			out.write(content);
			out.close();

			IResource resource = ResourcesPlugin.getWorkspace().getRoot();
			resource.refreshLocal(IResource.DEPTH_INFINITE, null);
		} catch (Exception e) {
				e.printStackTrace();
			}

			return new File(full_name).getAbsolutePath();
	}

}
