package cheddar.osate2_plugin;

import cheddar.config.Debug_Level;


public class Config {

	// Set the level of output of the plugin
	//
	public static Debug_Level Debug = Debug_Level.Very_Verbose;


	// Data port connections can be mapped either by Cheddar "precedence"
	// dependency or by "time triggered" Cheddar dependency
	// if Data_Port_To_Time_triggeret_Dependency is false, Cheddar precedencies are generated
	// otherwise time triggered entities are generated
	//
	public static boolean Data_Port_To_Time_Triggered_Dependency = false;


	// Store on which unit all AADL properties values have to be
	// converted. By default, it is in MilliSecond but it can be
	// overridden by the AADL Cheddar Properties "Exported_Attribute_Units"
	//
	public static Time_Units Exported_Attribute_Time_Units = Time_Units.MilliSecond;


	// For analysis motivations, one may want to produce Cheddar periodic tasks
	// from AADL periodic threads ; this is typically the case when from an AADL model
	// one expect to run a worst case analysis
	// If true, the following property expresses if for a given system, its sporadic threads must
	// be transform to periodic Cheddar task or to sporadic Cheddar task
	// The same mechanism also exits for AADL thread with a poisson process dispatching law
	// By default, we do not produce periodic Cheddar tasks for those kind of AADL threads
	//
	public static boolean SporadicToPeriodic = false;
	public static boolean PoissonToPeriodic = false;


	// False if Cheddar XML files must be generated in the "Cheddar_Output_Folder" folder
	// Generate files in the working directory instead
	//
	public static boolean Use_Default_Working_Directory = true;


	// Store folder where each generated files have to be stored (if working
	// directory is not selected)
	//
	public static String Cheddar_Output_Folder = "put here your prefered folder path";


	// Store full path and other argument to execute Cheddar binary
	//
	// Folder where all Cheddar files will be stored
	public static String Cheddar_Working_Folder = System.getProperty("user.home") + "/Desktop/Cheddar_Bin/";
	// Shell Variables required by Cheddar
	public static String Cheddar_Environment = "set CHEDDAR_INSTALL_PATH=" + Cheddar_Working_Folder + "&";
	// Folder where Cheddar is installed
	public static String Cheddar_Install_Folder = System.getProperty("user.home") + "/Desktop/Cheddar_Bin/";

}


