package cheddar.osate2_plugin;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;

import org.osate.ui.dialogs.Dialog;

public class Launch {

	public String executeCommand(String command, String environment, String working_folder) {

		Debug.Put("Command to launch : " + command + " in folder " + working_folder);
		StringBuffer output = new StringBuffer();

		try {
			String[] env = new String[1];
			env[0] = environment;
			File dir = new File(working_folder);

			new Thread(() -> {

				try {
					Process p = Runtime.getRuntime().exec(command, env, dir);

					BufferedReader inreader = new BufferedReader(new InputStreamReader(p.getInputStream()));
					BufferedReader errreader = new BufferedReader(new InputStreamReader(p.getErrorStream()));

					String line = "";
					while ((line = inreader.readLine()) != null) {
						output.append(line + "\n");
					}
					while ((line = errreader.readLine()) != null) {
						output.append(line + "\n");
					}

					p.waitFor();

					Debug.Put("Launch output =>" + output);

				} catch (Exception e) {
					Dialog.showInfo("Cannot run Cheddar tool on install dir :", Config.Cheddar_Install_Folder);
					e.printStackTrace();
				}
			}).start();

		} catch (Exception e) {
		}

		return output.toString();

	}


}
